#ifndef CONSENSUSSEQUENCE_HH
#define CONSENSUSSEQUENCE_HH 1

#include <iostream>
#include <vector>
#include <string>
#include <list>
#include "SequenceData.hh"
#include <SliceData.hh>

typedef list<SequenceData *> SequenceList;
typedef map<string, SequenceData *> SequenceMap;

using libSlice::SliceData;
using libSlice::ReadData;

class ConsensusSequence
{
public:
  ConsensusSequence(int contigCount, long index, ostream & out);
  ~ConsensusSequence();

  void addSlice(SliceData * slice);

  void printTasm(const string & asmblId,
                 const string & user,
                 const string & comment,
                 const string & method,
                 const string & caId,
                 string & mod_date,
                 int doQuality);

private:
  SequenceData * getSequence(const ReadData * rd, long offset, long index); 

  ostream & m_out;

  string m_nuc;
  string m_nucsequence;
  string m_qualclass;

  int m_contigCount;
  long m_curOffset;
  long m_curIndex;

  long m_depthCount;
  long m_sliceCount;
  long m_ambiguityCount;
  
  SequenceMap  m_sequenceMap;
  SequenceList m_sequenceList;
};

#endif
