#include "SequenceData.hh"
#include "Foundation.hh"

SequenceData::SequenceData(const ReadData * rd, long offset, long index)
{
  if (!rd)
  {
    throw Exception("ReadData cannot be NULL",
                        "SequenceData::SequenceData");
  }

  m_readData = rd;
  m_offset = offset;

  m_asmleft = m_asmright = index;

  m_nuc = "";
}

SequenceData::~SequenceData()
{ }

void SequenceData::addElement(long index, char nuc)
{
  m_asmright = index;
  m_nuc += nuc;
}

void SequenceData::printTasmRecord(ostream & out)
{
  out << "seq_name\t"  << m_readData->getSeqname()    << endl;
  out << "asm_lend\t"  << m_asmleft                   << endl;
  out << "asm_rend\t"  << m_asmright                  << endl;
  out << "seq_lend\t"  << m_readData->getSeqleft()    << endl;
  out << "seq_rend\t"  << m_readData->getSeqright()   << endl;
  out << "best\t"                                     << endl;
  out << "comment\t"                                  << endl;
  out << "db\t"                                       << endl;
  out << "offset\t"    << m_offset                    << endl;

  out << "lsequence\t" << m_nuc                       << endl;
}
